#ifndef MAINWINDOW_H
#define MAINWINDOW_H

#include <QMainWindow>
#include <QMenu>
#include <QMenuBar>
#include <QFileDialog>
#include <QMessageBox>
#include <QTreeView>

#include "xmlmodel.h"


QT_BEGIN_NAMESPACE
class QAction;
class QActionGroup;
class QLabel;
class QMenu;
QT_END_NAMESPACE

class MainWindow : public QMainWindow
{
    Q_OBJECT

public:
    MainWindow();

protected:
#ifndef QT_NO_CONTEXTMENU
    void contextMenuEvent(QContextMenuEvent *event) override;
#endif // QT_NO_CONTEXTMENU

private slots:
    void open();
    void close();
    void makeActive();

private:
    void createActions();
    void createMenus();

private:
    XmlModel* model;
    QTreeView* treeView;

    QMenu *fileMenu;
    QAction *openAct;
    QAction *closeAct;
    QAction *exitAct;
    QAction *makeActiveAct;
//    QLabel *infoLabel;
};

#endif
